unit Overpin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, System.UITypes;

type
  TForm4 = class(TForm)
    Button2: TButton;
    Button1: TButton;
    Label6: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    GroupBox3: TGroupBox;
    tenkey0: TSpeedButton;
    EscBtn: TSpeedButton;
    EnterBtn: TSpeedButton;
    ClearBtn: TSpeedButton;
    Tenkeydot: TSpeedButton;
    Tenkey1: TSpeedButton;
    tenkey2: TSpeedButton;
    tenkey3: TSpeedButton;
    tenkey4: TSpeedButton;
    tenkey5: TSpeedButton;
    tenkey6: TSpeedButton;
    tenkey7: TSpeedButton;
    tenkey8: TSpeedButton;
    tenkey9: TSpeedButton;
    AlignEdit1: TEdit;
    AlignEdit2: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AlignEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure AlignEdit2KeyPress(Sender: TObject; var Key: Char);
    procedure EscBtnClick(Sender: TObject);
    procedure AlignEdit1Click(Sender: TObject);
    procedure AlignEdit2Click(Sender: TObject);
    procedure EnterBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure tenkey0Click(Sender: TObject);
    procedure TenkeydotClick(Sender: TObject);
    procedure Tenkey1Click(Sender: TObject);
    procedure tenkey2Click(Sender: TObject);
    procedure tenkey3Click(Sender: TObject);
    procedure tenkey4Click(Sender: TObject);
    procedure tenkey5Click(Sender: TObject);
    procedure tenkey6Click(Sender: TObject);
    procedure tenkey7Click(Sender: TObject);
    procedure tenkey8Click(Sender: TObject);
    procedure tenkey9Click(Sender: TObject);
  private
    { Private 錾 }
    procedure OverpinCalcSub1(var Z,X,alfa,ttu,ttu1,DMD:double);{I[o[ssavZ _l}
    procedure OverpinCalcSub(z,x,jmcin:double);                   // I[o[svZ sub
    procedure OverpinCalMmain;                                    // I[o[svZ
    procedure OverpinCalcSub2(var Z,X,ttu,ttu1,ttuc,ttu1c:double);// I[o[savZ
    procedure EditMessend(key: pchar);
  protected
    procedure CreateParams(var Params: TCreateParams); Override;
  public
    { Public 錾 }
    procedure pindisp;                                            // vZsa\
    procedure OverPincalc(ZDM,D0M,ZMMAX,XXM,XXMZ: double);{I[o[svZ}
  end;

var
  Form4: TForm4;

implementation

uses geard,Gcalc,math,Gdatain;

{$R *.dfm}

var
  jmcin1,jmcin2: double;
  KeyEditF: integer;

procedure TForm4.ClearBtnClick(Sender: TObject);
begin
  case KeyEditF of
    1: alignedit1.Text := '';
    2: alignedit2.Text := '';
  end;
end;

procedure TForm4.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
  Params.WndParent := Application.Handle;
end;

procedure TForm4.EnterBtnClick(Sender: TObject);
var
  key: char;
begin
  Key := #13;
  case KeyEditF of
    1: alignedit1.OnKeyPress(nil, key);
    2: alignedit2.OnKeyPress(nil, key);
  end;
end;

procedure TForm4.EscBtnClick(Sender: TObject);
var
  key: char;
begin
  Key := #27;
  case KeyEditF of
    1: alignedit1.OnKeyPress(nil, key);
    2: alignedit2.OnKeyPress(nil, key);
  end;
end;

procedure TForm4.OverpinCalcSub2(var Z,X,ttu,ttu1,ttuc,ttu1c:double); // I[o[savZ
begin
  ttu := pi / 2 / Z - tan(GAS) + GAS - 2 * X * tan(AN) / Z;           // invvZp ʂ̒vZ ʃW[
  ttuc := ttu;                                                        // invvZp ʂ̒vZ ʃW[
  ttu1 := dmJ / Z / MN / cos(AN);                                     // invs = tans - s
  ttu1c := dmJc / Z / MN / cos(AN);                                   //         - / 2 / Z + invs + 2 * X * tann / Z
  ttu := ttu1 - ttu;                                                  // inv
  ttuc := ttu1c - ttuc;                                               // invc
  ttu1 := disinv(ttu);                                                // vZ   tC{[gvZ
  tau1 := ttu1;                                                       // Cp   2012 ǉ
  ttu1c := disinv(ttuc);                                              // cvZ   tC{[gvZ

//  mdk0 := Z * Mn /cos(B0) * cos(Gas) / COS(ttu1) + dmJ;                    // ̌vZƓoI[o[svZƓ
//  mdk0 := Z * Mn /cos(B0) * cos(Gas) / COS(ttu1) * cos(pi / 2 / Z) + dmJ;  //@ @@@@@@@@@@@I[o[svZƓ
  if round(Z) mod 2 = 0 then
    begin
      mdk0 := Z * Mn * cos(AN) / cos(ttu1) / sqrt(1- cos(AN)              // I[o[sa
                       * cos(AN) * sin(B0) * sin(B0)) + dmJ;
      mdkc0 := Z * Mn * cos(AN) / cos(ttu1c) / sqrt(1- cos(AN)            // I[o[sa
                       * cos(AN) * sin(B0) * sin(B0)) + dmJc;
    end
    else
    begin
      mdk0 := Z * Mn * cos(AN) / cos(ttu1) / sqrt(1- cos(AN)              // I[o[sa
                       * cos(AN) * sin(B0) * sin(B0)) * cos(pi / 2 / Z) + dmJ;
      mdkc0 := Z * Mn * cos(AN) / cos(ttu1c) / sqrt(1- cos(AN)            // I[o[sa
                       * cos(AN) * sin(B0) * sin(B0)) * cos(pi / 2 / Z) + dmJc;
    end;
end;

procedure TForm4.OverpinCalcSub1(var Z,X,alfa,ttu,ttu1,DMD:double);{I[o[ssavZ _l}
var
  ZV: double;
begin
  ZV := Z / cos(b0) / cos(b0) / cos (b0);                       // ԑ
  alfa := ZV * cos(AN) / (ZV + 2 * X);                          // saݒp
  alfa := arccos(alfa);                                         // ]ʎ͊pvZ
  ttu := pi / 2 / ZV - tan(AN) + AN - 2 * tan(AN) / ZV * X;     // ʂ̒vZ  ԑ
                                                                // / 2 / Zv - invn - 2 * X * tann / Zv
  ttu1 := tan(alfa) + ttu;                                      // ӌvZ
  DMD := ZV * MN * cos(AN) * (tan(ttu1) - ttu1 + ttu);          // DMD sa
  tau1 := ttu1;                                                 // Cp
  dmJc := DMD;
end;

procedure TForm4.OverPincalc(ZDM,D0M,ZMMAX,XXM,XXMZ: double);{I[o[svZ}
Label                                                           // ZDM   D0M sb`~a
  back2,back3;                                                  // ZMMAX őޯׯ XXM ]ʌW XXMZobNbV
var
  J: integer;
  alfa,ttu,ttu1,DMD:  double;
  ttuc,ttu1c:         double;
  mk0c,domc:           double;
begin
  OverpinCalcSub1(ZDM,XXM,alfa,ttu,ttu1,DMD);                   // I[o[ssavZ _l
  J := 0;
back2:
  if OverpinF = 16 then                                         // Œs 0.1sb`vZ
    begin
      if Mn < 0.25 then
        begin
          dmj := Ceil(DMD * 100);                               // 100{0.01 _؂グ
          dmj := dmj / 100;                                     // ֖߂
        end;
      if (0.8 > Mn) and (Mn >= 0.25) then
        begin
          dmj := Ceil(DMD * 20);                                // 20{0.05_؂グ
          dmj := dmj / 20;                                      // ֖߂
        end;
      if Mn >= 0.8 then
        begin
          dmj := Ceil(DMD * 10);                                // 10{0.1 _؂グ
          dmj := dmj / 10;                                      // ֖߂
        end;
      OverpinCalcSub2(ZDM,XXM,ttu,ttu1,ttuc,ttu1c);{I[o[savZ}
      mk0c := mdk0 + ZMMAX / sin(tau1);
      domc := (ZDM / cos(b0) + 2 + 2 *(Y - XXMZ)) * Mn;         // W~a   DK1 := (Z1 / COS(b0) + 2 + 2 * (Y - X2)) * MN;
      if mk0c < domc then                                       // ~aI[o[saꍇ
        begin                                                   // sa傫
          DMD := DMD + DMD / 100;
          goto back2;
        end;
      exit;
    end;
  if dm[J] > DMD then                                           // sȃI
      goto back3
    else
      if J < mdNo - 1 then
        begin
          J := J + 1;
          goto back2;
        end;
back3:
  if ((PRFF and 16 = 0) and (PRFF and 4 = 0)) or ((PRFF and 16 = 16) and (PRFF and 8 = 0)) then
    if (dm[J] < DMD) or (dm[J] > DMD * 1.251) or (dm[J] > dmJc * 1.4) then
      begin
        if (OverpinF = 1) or (OverpinF = 2) or (OverpinF = 4) or (OverpinF = 8) then
          begin
            LL := 'W[傫@́AobNbV傫A' + #13#10 +
                  '{vÕf[^[Ɏgpł钼ãsQ[W͗L܂B'  + #13#10 +
                  'sQ[W̐@ꍇ́A̓[hgpăsa͂ĂB'+ #13#10 +
                  '********************************************************************' + #13#10 +
                  '˂pŎȂꍇ́A˂Ԃ̌vZgpĉB';

            MessageDlg(LL,mtInformation,[mbOK],0);
          end;
        if PRFF and 16 = 0 then PRFF := PRFF or 4                           // ŝŗ_l\tO
                           else PRFF := PRFF or 8;                          // ŝŗ_l\tO

      end;
  if ((PRFF and 16 = 0) and (PRFF and 4 = 4)) or ((PRFF and 16 = 16) and (PRFF and 8 = 8)) then
      dmj := dmJc
    else
      dmj := dm[J];
  OverpinCalcSub2(ZDM,XXM,ttu,ttu1,ttuc,ttu1c); {I[o[savZ}
  if ((PRFF and 16 = 0) and (PRFF and 4 = 0)) or ((PRFF and 16 = 16) and (PRFF and 8 = 0)) then
    begin
      mk0c := mdk0 + ZMMAX / sin(tau1);     // I[o[sa-a
      domc := (ZDM / cos(b0) + 2 + 2 *(Y - XXMZ)) * Mn; // W~a   DK1 := (Z1 / COS(b0) + 2 + 2 * (Y - X2)) * MN;
      if mk0c < domc then                   // ~aI[o[saꍇ
        begin                               // sa傫
          DMD := DMD + DMD / 100.0;
          goto back2;
        end;
    end;
end;

procedure TForm4.OverpinCalcSub(z,x,jmcin:double);  //I[o[svZsub
var
  alfa,ttu,ttu1,DMD: double;
  ttuc,ttu1c: double;
begin
  OverpinCalcSub1(Z,X,alfa,ttu,ttu1,DMD);                                //I[o[ssavZ _l
  dmJ := jmcin;
  OverpinCalcSub2(Z,X,ttu,ttu1,ttuc,ttu1c);{s ڐGpvZ}
end;

procedure TForm4.OverpinCalMmain;  //I[o[s蓮͌vZ
begin
  PRFF := 0;
  if Z1 > 1 then
    begin
      OverpinCalcSub(z1,x1,jmcin1); //I[o[svZsub
      mdk1 := mdk0;
      dmj1 := dmj;
      mdkc1 := mdkc0;
      dmjc1 := dmjc;
      ZMMAX1 := Z1Mmax / sin(tau1);
      ZMMIN1 := Z1MMin / sin(tau1);
    end
    else PRFF := PRFF or 4;          //4 vZȂ
  if Z2 > 1 then
    begin
      PRFF := PRFF or 16;
      OverpinCalcSub(z2,x2,jmcin2); //I[o[svZsub
      mdk2 := mdk0;
      dmj2 := dmj;
      mdkc2 := mdkc0;
      dmjc2 := dmjc;
      ZMMAX2 := Z2Mmax / sin(tau1);
      ZMMIN2 := Z2MMin / sin(tau1);
    end
    else PRFF := PRFF or (16 + 8);  //8 vZȂ
end;

procedure TForm4.pindisp;     //vZsa\
begin
  Label2.Caption := 'vZvpsa@' + floatTostrF(dmJc1,ffGeneral,7,4);
  Label4.Caption := 'vZvpsa@' + floatTostrF(dmJc2,ffGeneral,7,4);
end;

procedure TForm4.EditMessend(key: pchar);
begin
  case KeyEditF of
    1: SendMessage(AlignEdit1.Handle, EM_REPLACESEL, 0, Integer(key));
    2: SendMessage(AlignEdit2.Handle, EM_REPLACESEL, 0, Integer(key));
  end;
end;

procedure TForm4.tenkey0Click(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '0';
  EditMessend(key);
end;

procedure TForm4.Tenkey1Click(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '1';
  EditMessend(key);
end;

procedure TForm4.tenkey2Click(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '2';
  EditMessend(key);
end;

procedure TForm4.tenkey3Click(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '3';
  EditMessend(key);
end;

procedure TForm4.tenkey4Click(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '4';
  EditMessend(key);
end;

procedure TForm4.tenkey5Click(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '5';
  EditMessend(key);
end;

procedure TForm4.tenkey6Click(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '6';
  EditMessend(key);
end;

procedure TForm4.tenkey7Click(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '7';
  EditMessend(key);
end;

procedure TForm4.tenkey8Click(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '8';
  EditMessend(key);
end;

procedure TForm4.tenkey9Click(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '9';
  EditMessend(key);
end;

procedure TForm4.TenkeydotClick(Sender: TObject);
var
  Key: Pchar;
begin
  Key := '.';
  EditMessend(key);
end;

procedure tenkeyset;
begin
  with Form4 do begin
    Groupbox3.Height := 175;
    Groupbox3.Width := 129;
    Tenkey0.Height := 25;
    Tenkeydot.Height := 25;
    Tenkey1.Height := 25;
    Tenkey2.Height := 25;
    Tenkey3.Height := 25;
    Tenkey4.Height := 25;
    Tenkey5.Height := 25;
    Tenkey6.Height := 25;
    Tenkey7.Height := 25;
    Tenkey8.Height := 25;
    Tenkey9.Height := 25;
    ClearBtn.Height := 25;
    EscBtn.Height := 25;
    EnterBtn.Height := 25;
    Tenkey0.Width := 33;
    Tenkeydot.Width := 33;
    Tenkey1.Width := 33;
    Tenkey2.Width := 33;
    Tenkey3.Width := 33;
    Tenkey4.Width := 33;
    Tenkey5.Width := 33;
    Tenkey6.Width := 33;
    Tenkey7.Width := 33;
    Tenkey8.Width := 33;
    Tenkey9.Width := 33;
    ClearBtn.Width := 33;
    EscBtn.Width := 33;
    EnterBtn.Width := 77;
    Tenkey1.Left := 4;
    Tenkey4.Left := 4;
    Tenkey7.Left := 4;
    ClearBtn.Left := 4;
    EscBtn.Left := 4;
    Tenkey0.Left := 48;
    Tenkey2.Left := 48;
    Tenkey5.Left := 48;
    Tenkey8.Left := 48;
    EnterBtn.Left := 48;
    Tenkeydot.Left := 92;
    Tenkey3.Left := 92;
    Tenkey6.Left := 92;
    Tenkey9.Left := 92;
    EscBtn.top := 146;
    EnterBtn.Top := 146;
    Tenkey0.Top := 115;
    TenkeyDot.Top := 115;
    ClearBtn.Top := 115;
    Tenkey1.Top := 84;
    Tenkey2.Top := 84;
    Tenkey3.Top := 84;
    Tenkey4.Top := 53;
    Tenkey5.Top := 53;
    Tenkey6.Top := 53;
    Tenkey7.Top := 22;
    Tenkey8.Top := 22;
    Tenkey9.Top := 22;
  end;
end;


procedure TForm4.FormCreate(Sender: TObject);
begin
  ClientHeight := 300;
  ClientWidth :=  490;
  with Label1 do begin
    Top := 10;
    Left := 10;
    Font.Height := 12;
    Height := 18;
  end;
  with Label2 do begin
    Top := 56;
    Left := 64;
    Font.Height := 12;
    Height := 18;
  end;
  with Label3 do begin
    Top := 80;
    Left := 64;
    Font.Height := 12;
    Height := 18;
  end;
  with AlignEdit1 do begin
    Top := 78;
    Left := 240;
    Height := 25;
    Width := 80;
    Font.Height := 12;
    Text := '';
  end;
  with Label4 do begin
    Top := 136;
    Left := 64;
    Font.Height := 12;
    Height := 18;
  end;
  with Label5 do begin
    Top := 160;
    Left := 64;
    Font.Height := 12;
    Height := 18;
  end;
  with AlignEdit2 do begin
    Top := 158;
    Left := 240;
    Height := 25;
    Width := 80;
    Font.Height := 12;
    Text := '';
  end;
  with button1 do begin
    top := 210;
    Left := 350;
    Height := 25;
    Width := 73;
    Font.Height := 12;
  end;
  with button2 do begin
    top := 246;
    Left := 350;
    Height := 25;
    Width := 73;
    Font.Height := 12;
  end;
  with Label6 do begin
    Top := 215;
    Left := 30;
    Font.Height := 13;
    Height := 18;
    Font.Color := clBlue;
    Caption := '@vZI[o[saĕύXꍇ́A' +#13#10 +
               '̓[hsĂB' +#13#10 +
               '@lۂ߂ꍇ́A傫l֕̕ύXA' +#13#10 +
               '؂̂Ă͂Ȃ悤ɂ܂B';
  end;
  tenkeyset;
  GroupBox3.Top := 10;
  GroupBox3.Left := 350;

end;

procedure TForm4.Button1Click(Sender: TObject);
var
  ERFF1,ERFF2: integer;
begin
  if Z1 > 1 then Val(AlignEdit1.Text,jmcin1,ERFF1);
  if ERFF1 <> 0 then exit;
  if Z2 > 1 then VAL(AlignEdit2.Text,jmcin2,ERFF2)
            else ERFF2 := 0;
  if ERFF2 <> 0 then exit;
  if Z1 > 1 then
    begin
      if (jmcin1 > 0) and (ERFF1 = 0) then
        begin
          if (jmcin1 > dmJc1 * 1.15) or (jmcin1 < dmJc1 * 0.9) then
            begin
              LL := 'Z1̃saAvZƂȂႢ܂A낵łB';
              if MessageDlg(LL, mtConfirmation,[mbYes, mbNo], 0) = mrNo then exit;
            end;
        end
        else exit;
    end;
  if Z2 > 1 then
    begin
      if (jmcin2 > 0) and (ERFF2 = 0) then
        begin
          if (jmcin2 > dmJc2 * 1.15) or (jmcin2 < dmJc2 * 0.9) then
            begin
              LL := 'Z2̃saAvZƂȂႢ܂A낵łB';
              if MessageDlg(LL, mtConfirmation,[mbYes,mbNo], 0) = mrNo then exit;
            end;
        end
        else exit;
    end;
  if Z1 > 1 then
    if (jmcin1 > dmJc1 * 1.5) or (jmcin1 < dmJc1 * 0.8) then
      begin
        LL := 'Z1̃saAvZƂ܂ɂႢ܂ACĂB';
        if MessageDlg(LL, mtWarning,[mbYes,mbNo], 0) = mrYes then exit;
      end;
  if Z2 > 1 then
    if (jmcin2 > dmJc2 * 1.5) or (jmcin2 < dmJc2 * 0.8) then
      begin
        LL := 'Z2̃saAvZƂ܂ɂႢ܂ACĂB';
        if MessageDlg(LL, mtWarning,[mbYes,mbNo], 0) = mrYes then exit;
      end;
  OverpinCalMmain;  //I[o[s蓮͌vZ
  Form1.Show;
  hide;
  dispoutput;{ʌvZʕ\}
  Gbitbotcalc;{vZrbg{^̐ݒ}
end;

procedure TForm4.Button2Click(Sender: TObject);
begin
  Form1.Show;
  hide;
  dispoutput;{ʌvZʕ\}
  Gbitbotcalc;{vZrbg{^̐ݒ}
end;

procedure TForm4.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form1.show;
  dispoutput;{ʌvZʕ\}
  Gbitbotcalc;{vZrbg{^̐ݒ}
end;

procedure TForm4.AlignEdit1Click(Sender: TObject);
begin
  KeyEditF := 1;
end;

procedure TForm4.AlignEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then Button1Click(nil);
  if key = #27 then Button2Click(nil);
end;

procedure TForm4.AlignEdit2Click(Sender: TObject);
begin
  KeyEditF := 2;
end;

procedure TForm4.AlignEdit2KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then Button1Click(nil);
  if key = #27 then Button2Click(nil);
end;

end.
